// CodeChef September Long Challenge, problem CAOS1
// Tester's solution. Written by Sergey Kulik

#include <cstdio>
#include <cassert>
#include <algorithm>
using namespace std;

int tqn,tqi,n,m,i,j,Left[1111][1111],Right[1111][1111],Top[1111][1111],Down[1111][1111],ret,a1,a2;
char a[1111][1111],dump[1111];

int main (int argc, char * const argv[]) {
	scanf("%d\n",&tqn); // get the number of the test cases
	assert(1<=tqn&&tqn<=100); // input validation
	for(tqi=0;tqi<tqn;tqi++){
		scanf("%d%d\n",&n,&m); // get the dimensions of the grid
		assert(1<=n&&n<=50&&1<=m&&m<=50); // input validation
		for(i=1;i<=n;i++){ // n rows
			for(j=1;j<=m;j++){ // m columns
				a[i][j]=getchar(); // reading the grid
				assert(a[i][j]=='#'||a[i][j]=='^'); // input validation
			}
			assert(getchar()==10); // read the newline
		}
		for(i=1;i<=n+1;i++)for(j=1;j<=m+1;j++)Top[i][j]=Down[i][j]=Left[i][j]=Right[i][j]=0; // init four DP arrays
		for(i=1;i<=n;i++)for(j=1;j<=m;j++)if(a[i][j]=='^'){ // if the cell is free
			Left[i][j]=1+Left[i][j-1]; // calculate the number of free cells to the left
			Top[i][j]=1+Top[i-1][j]; // calculate the number of free cells to the top
		} // otherwise the number of free cells to the left and to the top of the cell, _including itself_ is obviously zero
		for(i=n;i;i--)for(j=m;j;j--)if(a[i][j]=='^'){ // if the cells is free
			Right[i][j]=1+Right[i][j+1]; // calculate the number of free cells to the right
			Down[i][j]=1+Down[i+1][j]; // calculate the number of free cells to the bottom
		}
		ret=0; // answer
		for(i=1;i<=n;i++)for(j=1;j<=m;j++)if(a[i][j]=='^'){ // if the cell is free
			a1=min(Left[i][j-1],Right[i][j+1]); // calculating minimum
			a2=min(Top[i-1][j],Down[i+1][j]); // calculating minimum
			if(min(a1,a2)>1)++ret; // 2 is the smallest prime, so we can check that the min(L,R,T,B) is >= 2
		}
		printf("%d\n",ret); // output the answer
	}
    return 0;
}
